/*******************************************************************************
 * Copyright (c) 2012 IBM Corporation and others.
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * and Eclipse Distribution License v. 1.0 which accompanies this distribution.
 *
 * The Eclipse Public License is available at http://www.eclipse.org/legal/epl-v10.html
 * and the Eclipse Distribution License is available at
 * http://www.eclipse.org/org/documents/edl-v10.php.
 *
 * Contributors:
 *
 *     Michael Fiedler     - initial API and implementation for Bugzilla adapter
 *     Jad El-khoury        - initial implementation of code generator (https://bugs.eclipse.org/bugs/show_bug.cgi?id=422448)
 *
 * This file is generated by org.eclipse.lyo.oslc4j.codegenerator
 *******************************************************************************/
package se.kth.md.adaptors.basicexample.services;

import java.io.IOException;
import java.io.PrintWriter;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.TreeSet;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.Consumes;
import javax.ws.rs.DELETE;
import javax.ws.rs.FormParam;
import javax.ws.rs.GET;
import javax.ws.rs.HeaderParam;
import javax.ws.rs.POST;
import javax.ws.rs.PUT;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.QueryParam;
import javax.ws.rs.WebApplicationException;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.Response.Status;
import javax.ws.rs.core.UriInfo;
import javax.ws.rs.core.UriBuilder;

import org.apache.wink.json4j.JSONObject;
import org.eclipse.lyo.oslc4j.provider.json4j.JsonHelper;
import org.eclipse.lyo.oslc4j.core.annotation.OslcCreationFactory;
import org.eclipse.lyo.oslc4j.core.annotation.OslcDialog;
import org.eclipse.lyo.oslc4j.core.annotation.OslcDialogs;
import org.eclipse.lyo.oslc4j.core.annotation.OslcQueryCapability;
import org.eclipse.lyo.oslc4j.core.annotation.OslcService;
import org.eclipse.lyo.oslc4j.core.model.Compact;
import org.eclipse.lyo.oslc4j.core.model.OslcConstants;
import org.eclipse.lyo.oslc4j.core.model.OslcMediaType;
import org.eclipse.lyo.oslc4j.core.model.Preview;
import org.eclipse.lyo.oslc4j.core.model.ServiceProvider;
import org.eclipse.lyo.oslc4j.core.model.Link;
import org.eclipse.lyo.oslc4j.core.model.AbstractResource;

import se.kth.md.adaptors.basicexample.BasicAdaptorManager;
import se.kth.md.adaptors.basicexample.BasicAdaptorConstants;
import se.kth.md.adaptors.basicexample.servlet.ServiceProviderCatalogSingleton;
import se.kth.md.adaptors.basicexample.resources.ExtendedRequirement;
import se.kth.md.adaptors.basicexample.resources.Person;
import se.kth.md.adaptors.basicexample.resources.Requirement;
import se.kth.md.adaptors.basicexample.servlet.ServletListener;

// Start of user code imports
// End of user code

// Start of user code pre_class_code
// End of user code
@OslcService(BasicAdaptorConstants.EXTENDED_REQUIRMENT_MANAGEMENT_DOMAIN)
@Path("req-services/{serviceProviderId}/extendedRequirements")
public class ExtendedRequirementService
{
    @Context private HttpServletRequest httpServletRequest;
    @Context private HttpServletResponse httpServletResponse;
    @Context private UriInfo uriInfo;

    // Start of user code class_attributes
    // End of user code

    // Start of user code class_methods
    // End of user code

    public ExtendedRequirementService()
    {
        super();
    }

	private String getCurrentPathString() {
        return String.format("%s/%s", ServletListener.getServicesBase(), uriInfo.getPath());
        //return uriInfo.getAbsolutePath().toString();
    }

    @OslcQueryCapability
    (
        title = "QueryCapabilityRequirements",
        label = "QueryCapabilityRequirements",
        resourceShape = OslcConstants.PATH_RESOURCE_SHAPES + "/" + BasicAdaptorConstants.PATH_EXTENDEDREQUIREMENT,
        resourceTypes = {BasicAdaptorConstants.TYPE_EXTENDEDREQUIREMENT},
        usages = {OslcConstants.OSLC_USAGE_DEFAULT}
    )
    @GET
    @Path("requirements")
    @Produces({OslcMediaType.APPLICATION_RDF_XML, OslcMediaType.APPLICATION_XML, OslcMediaType.APPLICATION_JSON})
    public ExtendedRequirement[] queryExtendedRequirements(
                                                    @PathParam("serviceProviderId") final String serviceProviderId ,
                                                     @QueryParam("oslc.where") final String where,
                                                     @QueryParam("page") final String pageString,
                                                    @QueryParam("limit") final String limitString) throws IOException, ServletException
    {
        int page=0;
        int limit=20;
        if (null != pageString) {
            page = Integer.parseInt(pageString);
        }
        if (null != limitString) {
            limit = Integer.parseInt(limitString);
        }

        // Start of user code queryExtendedRequirements
        // Here additional logic can be implemented that complements main action taken in BasicAdaptorManager
        // End of user code

        final List<ExtendedRequirement> resources = BasicAdaptorManager.queryExtendedRequirements(httpServletRequest, serviceProviderId, where, page, limit);
        return resources.toArray(new ExtendedRequirement [resources.size()]);
    }

    @GET
    @Path("requirements")
    @Produces({ MediaType.TEXT_HTML })
    public Response queryExtendedRequirementsAsHtml(
                                    @PathParam("serviceProviderId") final String serviceProviderId ,
                                       @QueryParam("oslc.where") final String where,
                                       @QueryParam("page") final String pageString,
                                    @QueryParam("limit") final String limitString) throws ServletException, IOException
    {
        int page=0;
        int limit=20;
        if (null != pageString) {
            page = Integer.parseInt(pageString);
        }
        if (null != limitString) {
            limit = Integer.parseInt(limitString);
        }

        // Start of user code queryExtendedRequirementsAsHtml
        // End of user code

        final List<ExtendedRequirement> resources = BasicAdaptorManager.queryExtendedRequirements(httpServletRequest, serviceProviderId, where, page, limit);

        if (resources!= null) {
            httpServletRequest.setAttribute("resources", resources);
            // Start of user code queryExtendedRequirementsAsHtml_setAttributes
            // End of user code

            httpServletRequest.setAttribute("queryUri",
                    getCurrentPathString() + "?oslc.paging=true");
            if (resources.size() > limit) {
                resources.remove(resources.size() - 1);
                httpServletRequest.setAttribute("nextPageUri",
                        getCurrentPathString() + "?oslc.paging=true&amp;page=" + (page + 1));
            }
            RequestDispatcher rd = httpServletRequest.getRequestDispatcher("/se/kth/md/adaptors/basicexample/extendedrequirementscollection.jsp");
            rd.forward(httpServletRequest,httpServletResponse);
        }

        throw new WebApplicationException(Status.NOT_FOUND);
    }

    @OslcDialog
    (
         title = "RequirementSelectionDialog",
         label = "RequirementSelectionDialog",
         uri = "req-services/{serviceProviderId}/extendedRequirements/selector",
         hintWidth = "45px",
         hintHeight = "10px",
         resourceTypes = {BasicAdaptorConstants.TYPE_EXTENDEDREQUIREMENT},
         usages = {OslcConstants.OSLC_USAGE_DEFAULT}
    )
    @GET
    @Path("selector")
    @Consumes({ MediaType.TEXT_HTML, MediaType.WILDCARD })
    public void ExtendedRequirementSelector(
        @QueryParam("terms") final String terms
        , @PathParam("serviceProviderId") final String serviceProviderId
        ) throws ServletException, IOException
    {
        try {
            // Start of user code ExtendedRequirementSelector_init
            // End of user code

            httpServletRequest.setAttribute("selectionUri",getCurrentPathString());
            // Start of user code ExtendedRequirementSelector_setAttributes
            // End of user code

            if (terms != null ) {
                httpServletRequest.setAttribute("terms", terms);
                final List<ExtendedRequirement> resources = BasicAdaptorManager.ExtendedRequirementSelector(httpServletRequest, serviceProviderId, terms);
                if (resources!= null) {
                            httpServletRequest.setAttribute("resources", resources);
                            RequestDispatcher rd = httpServletRequest.getRequestDispatcher("/se/kth/md/adaptors/basicexample/extendedrequirementselectorresults.jsp");
                            rd.forward(httpServletRequest, httpServletResponse);
                }
                //a empty search should return an empty list and not NULL!
                throw new WebApplicationException(Status.NOT_FOUND);

            } else {
                try {
                    RequestDispatcher rd = httpServletRequest.getRequestDispatcher("/se/kth/md/adaptors/basicexample/extendedrequirementselector.jsp");
                    rd.forward(httpServletRequest, httpServletResponse);
                } catch (Exception e) {
                    throw new ServletException(e);
                }
            }
        } catch (Exception e) {
            throw new WebApplicationException(e);
        }
    }

    @GET
    @Path("{resourceId}")
    @Produces({OslcMediaType.APPLICATION_RDF_XML, OslcMediaType.APPLICATION_XML, OslcMediaType.APPLICATION_JSON})
    public ExtendedRequirement getExtendedRequirement(
                @PathParam("serviceProviderId") final String serviceProviderId, @PathParam("resourceId") final String resourceId
        ) throws IOException, ServletException, URISyntaxException
    {
        // Start of user code getResource_init
        // End of user code

        final ExtendedRequirement aExtendedRequirement = BasicAdaptorManager.getExtendedRequirement(httpServletRequest, serviceProviderId, resourceId);

        if (aExtendedRequirement != null) {
            // Start of user code getExtendedRequirement
            // End of user code
            return aExtendedRequirement;
        }

        throw new WebApplicationException(Status.NOT_FOUND);
    }

	@GET
    @Path("{resourceId}")
	@Produces({OslcMediaType.APPLICATION_X_OSLC_COMPACT_XML})
    public Compact getExtendedRequirementCompact(
        @PathParam("serviceProviderId") final String serviceProviderId, @PathParam("resourceId") final String resourceId
        ) throws ServletException, IOException, URISyntaxException
    {
        // Start of user code getExtendedRequirementAsHtml_init
        // End of user code

        final ExtendedRequirement aExtendedRequirement = BasicAdaptorManager.getExtendedRequirement(httpServletRequest, serviceProviderId, resourceId);

        if (aExtendedRequirement != null) {
            final Compact compact = new Compact();

            compact.setAbout(aExtendedRequirement.getAbout());

            //String iconUri = "https://landfill.bugzilla.org/bugzilla-4.4-branch/images/favicon.ico";
            //compact.setIcon(new URI(iconUri));

            //Create and set attributes for OSLC preview resource
        // Start of user code getExtendedRequirementAsHtml_smallPreview
            final Preview smallPreview = new Preview();
            smallPreview.setHintHeight("11em");
            smallPreview.setHintWidth("45em");
            smallPreview.setDocument(new URI(compact.getAbout().toString() + "/smallPreview"));
            compact.setSmallPreview(smallPreview);
		// End of user code

            //Use the HTML representation of a change request as the large preview as well
		// Start of user code getExtendedRequirementAsHtml_largePreview
            final Preview largePreview = new Preview();
            largePreview.setHintHeight("20em");
            largePreview.setHintWidth("45em");
            largePreview.setDocument(compact.getAbout());
            compact.setLargePreview(largePreview);
		// End of user code

            return compact;
        }

        throw new WebApplicationException(Status.NOT_FOUND);
    }

	@GET
    @Path("{resourceId}/smallPreview")
    @Produces({ MediaType.TEXT_HTML })
    public void getExtendedRequirementsmallPreview (
        @PathParam("serviceProviderId") final String serviceProviderId, @PathParam("resourceId") final String resourceId
        ) throws ServletException, IOException, URISyntaxException
    {
        // Start of user code getExtendedRequirementAsHtml_init
        // End of user code

        final ExtendedRequirement aExtendedRequirement = BasicAdaptorManager.getExtendedRequirement(httpServletRequest, serviceProviderId, resourceId);

        if (aExtendedRequirement != null) {
            httpServletRequest.setAttribute("aExtendedRequirement", aExtendedRequirement);

            RequestDispatcher rd = httpServletRequest.getRequestDispatcher("/se/kth/md/adaptors/basicexample/extendedrequirement_preview_small.jsp");
            rd.forward(httpServletRequest,httpServletResponse);
            return;
        }

        throw new WebApplicationException(Status.NOT_FOUND);
    }

    @GET
    @Path("{resourceId}")
    @Produces({ MediaType.TEXT_HTML })
    public Response getExtendedRequirementAsHtml(
        @PathParam("serviceProviderId") final String serviceProviderId, @PathParam("resourceId") final String resourceId
        ) throws ServletException, IOException, URISyntaxException
    {
        // Start of user code getExtendedRequirementAsHtml_init
        // End of user code

        final ExtendedRequirement aExtendedRequirement = BasicAdaptorManager.getExtendedRequirement(httpServletRequest, serviceProviderId, resourceId);

        if (aExtendedRequirement != null) {
            httpServletRequest.setAttribute("aExtendedRequirement", aExtendedRequirement);
            // Start of user code getExtendedRequirementAsHtml_setAttributes
            // End of user code

            RequestDispatcher rd = httpServletRequest.getRequestDispatcher("/se/kth/md/adaptors/basicexample/extendedrequirement.jsp");
            rd.forward(httpServletRequest,httpServletResponse);
        }

        throw new WebApplicationException(Status.NOT_FOUND);
    }

    @PUT
    @Path("{resourceId}")
    @Consumes({OslcMediaType.APPLICATION_RDF_XML, OslcMediaType.APPLICATION_XML, OslcMediaType.APPLICATION_JSON})
    public Response updateExtendedRequirement(
            @HeaderParam("If-Match") final String eTagHeader,
            @PathParam("serviceProviderId") final String serviceProviderId, @PathParam("resourceId") final String resourceId ,
            final ExtendedRequirement aResource
        ) throws IOException, ServletException
    {
        // Start of user code updateExtendedRequirement_init
        // End of user code
        final ExtendedRequirement originalResource = BasicAdaptorManager.getExtendedRequirement(httpServletRequest, serviceProviderId, resourceId);

        if (originalResource != null) {
            try {
                final String originalETag = BasicAdaptorManager.getETagFromExtendedRequirement(originalResource);

                if ((eTagHeader == null) || (originalETag.equals(eTagHeader))) {
                    // Start of user code updateExtendedRequirement
                    // End of user code
                    final ExtendedRequirement updatedResource = BasicAdaptorManager.updateExtendedRequirement(httpServletRequest, aResource, serviceProviderId, resourceId);
                    httpServletResponse.setHeader("ETag", BasicAdaptorManager.getETagFromExtendedRequirement(updatedResource));
                    return Response.ok().build();
                }
                else {
                    throw new WebApplicationException(Status.PRECONDITION_FAILED);
                }

            } catch (Exception e) {
                e.printStackTrace();
                throw new WebApplicationException(e);
            }

        }
        else {
            throw new WebApplicationException(Status.NOT_FOUND);
        }
    }


}
